/*
 * Created on 22.09.2004
 *
 */
package de.kleopatra.forms.examples.bookmanager;

import java.util.*;

import javax.swing.JComponent;

import de.kleopatra.view.binding.*;

/**
 * Form as editor for a Book.
 * 
 * @author (C) 2004 Jeanette Winzenburg, Berlin
 * @version $Revision: 1.4 $ - $Date: 2004/10/04 11:56:04 $
 */
public class BookEditorForm extends AbstractBoundForm {

  public static final String BOOKS_DIALOG_RESOURCE = "booksdialog";
  public static final String BOOKS_BUTTON_BAR = "booksokcancel";

//-------------------- override/implement Form
  
  public String getResource() {
    return BOOKS_DIALOG_RESOURCE;
  }
  protected String getButtonResource() {
    return BOOKS_BUTTON_BAR;
  }

  protected void bind(JComponent form) {
    binding = new BeanBinding(form, getTarget(), true);
    binding.setBufferEnabled(true);
    binding.bindTextInput("title");
    binding.bindTextInput("authors");
    binding.bindBooleanInput("available");
    binding.bindTextAreaInput("review");
//    binding.bindListInput("readers", null, "readers");
    bindCustomMetaData();
  }

   private void bindCustomMetaData() {
    List list = new ArrayList();
    BindingMetaData dateMetaData = 
      new FormattedTextBindingMetaData("release", "releaseDate");
    dateMetaData.setTargetClass(Date.class);
    list.add(dateMetaData);
    
    BindingMetaData intMetaData = new FormattedTextBindingMetaData("price");
    intMetaData.setTargetClass(int.class);
    list.add(intMetaData);

    binding.bind(list);
    
  }
}
