/*
 * Created on 08.07.2004
 *
 */
package de.kleopatra.forms.examples.data;

import javax.swing.DefaultListModel;
import javax.swing.ListModel;

import com.jgoodies.binding.beans.Model;

/**
 * @author (C) 2004 Jeanette Winzenburg, Berlin
 * @version $Revision: 1.1.1.1 $ - $Date: 2004/09/21 08:42:37 $
 */
public class ComboData extends Model {

  private static String[] countries = { "Egypt", "Rome", "Cuba", "Nicaragua",
                                        "Costa Rica" };
  private static String[] countryCodes = { "20", "39", "53", "505", "506" };
  DefaultListModel countriesModel;
  DefaultListModel codesModel;
  ListModel currentList;
  String currentData;
  
  public ComboData() {
    countriesModel = createDefaultListModel(countries);
    codesModel = createDefaultListModel(countryCodes);
    toggleList();
  }
  
  public ListModel getList() {
    return currentList;
  }

  public String getCurrent() {
    return currentData;
  }
  
  public void setCurrent(String current) {
    String oldCurrent = getCurrent();
    currentData = current;
    firePropertyChange("current", oldCurrent, getCurrent());
  }
  
  public void toggleList() {
    ListModel oldList = getList();
    if (oldList != countriesModel) {
      currentList = countriesModel;
    } else {
      currentList = codesModel;
    }
    firePropertyChange("list", oldList, getList());
  }
  
  private DefaultListModel createDefaultListModel(String[] items) {
    DefaultListModel l = new DefaultListModel();
    for (int i = 0; i < items.length; i++) {
      l.addElement(items[i]);
    }
    return l;
  }
}
