/*
 * Created on 25.06.2004
 *
 */
package de.kleopatra.forms.examples.data;

import javax.swing.DefaultListModel;

/**
 * @author (C) 2004 Jeanette Winzenburg, Berlin
 * @version $Revision: 1.2 $ - $Date: 2004/09/28 11:03:26 $
 */
public class CountryCodeResolver {

  private static String[] countries = { "Egypt", "Rome", "Cuba", "Nicaragua",
                                        "Costa Rica" };
  private static String[] countryCodes = { "20", "39", "53", "505", "506" };
  public static DefaultListModel countriesModel = createDefaultListModel(countries);
  static DefaultListModel codesModel = createDefaultListModel(countryCodes);
  static String getCodeForCountry(String country) {
    String code = getCorrespondingEntry(country, countriesModel, codesModel);
    if (code == null) {
      countriesModel.addElement(country);
      codesModel.addElement("??");
      code = "??";
    }
    return code;
  }

  static String getCountryForCode(String code) {
    return getCorrespondingEntry(code, codesModel, countriesModel);
  }

  static boolean isValidCode(String countryCode) {
    return (countryCode != null) && (!"??".equals(countryCode));
  }

  private static DefaultListModel createDefaultListModel(String[] items) {
    DefaultListModel l = new DefaultListModel();
    for (int i = 0; i < items.length; i++) {
      l.addElement(items[i]);
    }
    return l;
  }

  private static String getCorrespondingEntry(String country,
      DefaultListModel source, DefaultListModel target) {
    int index = source.indexOf(country);
    if (index < 0) {
      return null;
    }
    return (String) target.get(index);
  }
}
