/*
 * Created on 11.05.2004
 *
 */
package de.kleopatra.forms.examples.data;

import java.util.Date;

import com.jgoodies.binding.beans.Model;

/**
 * Just some bean...
 */
public class DataObject extends Model {

  private String country;
  private String name;
  private String phone;
  private String countryCode;
  private String notes;
  private String profession;
  private int age = 40;
  public DataObject(String name, String phone, String country) {
    this.name = name;
    this.phone = phone;
    this.country = country;
  }

  public void setName(String name) {
    String oldName = getName();
    this.name = name;
    firePropertyChange("name", oldName, getName());
    addLog("new Name: " + getName());
  }

  public String getName() {
    return name;
  }

  public String getProfession() {
    return profession;
  }

  public void setProfession(String profession) {
    String oldProfession = getProfession();
    this.profession = profession;
    firePropertyChange("profession", oldProfession, getProfession());
  }

  public int getAge() {
    return age;
  }

  public void setAge(int age) {
    int oldAge = getAge();
    this.age = age;
    firePropertyChange("age", oldAge, getAge());
  }

  public void setCountry(String country) {
    String oldCountry = getCountry();
    String oldCode = getCountryCode();
    boolean oldReachable = isReachable();
    this.country = country;
    firePropertyChange("country", oldCountry, getCountry());
    firePropertyChange("countryCode", oldCode, getCountryCode());
    firePropertyChange("reachable", oldReachable, isReachable());
    addLog("New Country/code: " + getCountry() + "/" + getCountryCode());
  }

  public String getCountry() {
    return country;
  }

  public void setPhone(String phone) {
    String oldPhone = getPhone();
    this.phone = phone;
    firePropertyChange("phone", oldPhone, getPhone());
  }

  public String getPhone() {
    return phone;
  }

  public String getCountryCode() {
    return getCountryCode(getCountry());
  }

  private String getCountryCode(String country) {
    return CountryCodeResolver.getCodeForCountry(country);
  }

  public boolean isReachable() {
    boolean result = (getPhone() != null) //&& (getPhone().indexOf("?") >= 0);
           && CountryCodeResolver.isValidCode(getCountryCode());
    return result;
  }

  public String getNotes() {
    return notes;
  }

  private void addLog(String entry) {
    String changedNotes = getNotes() + "\n" + new Date() + "\n" + entry;
    setNotes(changedNotes);
  }

  public void setNotes(String notes) {
    String oldNotes = getNotes();
    this.notes = notes;
    firePropertyChange("notes", oldNotes, getNotes());
  }

  public String getDescription() {
    return "Name/Phone/Fax/Notes: " + getName() + " / " + getPhone() + " / "
           + getCountry();    // + " / " + getNotes();
  }

  public static final String[] PROFESSION_IDS = { "queen", "artist",
                                                  "scientist" };
  public static final String[] PROFESSIONS = { "QUEEN", "ARTIST",
                                               "SCIENTIST" };
}
