/*
 * Created on 19.08.2004
 *
 */
package de.kleopatra.forms.examples.data;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.DefaultListModel;
import javax.swing.ListModel;

import com.jgoodies.binding.value.AbstractValueModel;


/**
 * A list of DataObjects with a notion of current.
 * 
 * 
 * @author (C) 2004 Jeanette Winzenburg, Berlin
 * @version $Revision: 1.2 $ - $Date: 2004/09/29 14:42:18 $
 */
public class SampleController extends AbstractValueModel
implements PropertyChangeListener {

//------------------ ValueModel  
  public Object getValue() {
    return getDataObject();
  }
  public void setValue(Object newValue) {
    setDataObject((DataObject) newValue);
  }
// ----------------- access properties
  
  public ListModel getDataList() {
    return getList();
  }

  public DataObject getDataObject() {
    return current;
  }

  public void setDataObject(DataObject selected) {
    DataObject oldData = getDataObject();
    current = selected;
    firePropertyChange("dataObject", oldData, getDataObject());
    fireValueChange(oldData, getDataObject());
  }

//----------------------- PropertyChangeListener 
  
  /** indirectly fires a contentChanged if one of the
   *  contained DataObjects reports a propertyChange.
   */
  public void propertyChange(PropertyChangeEvent evt) {
    int index = getList().indexOf(evt.getSource());
    if (index < 0) {
      return;
    }
    getList().setElementAt(evt.getSource(), index);
  }
  
//---------------------- helper
  
  private DefaultListModel getList() {
    if (list == null) {
      list = createListModel();
    }
    return list;
  }

  private DefaultListModel createListModel() {
    DefaultListModel list = new DefaultListModel();
    for (int i = 0; i < records.length; i++) {
      list.addElement(records[i]);
      records[i].addPropertyChangeListener(this);
    }
    return list;
  }

  //    private DefaultComboBoxModel listModel;
  private DefaultListModel list;
  private DataObject current;
  private DataObject[] records = {
    new DataObject("Kleopatra", "100", "Egypt"),
    new DataObject("Nofretete", "001", "Egypt"),
    new DataObject("Frida", "9876", "Mexico") };

}
