/*
 * Created on 09.09.2003
 *
 */
package custom.forms.view;

import java.awt.Component;

import javax.swing.Action;

import de.kleopatra.view.presentation.*;

/**
 * @author (C) Jeanette Winzenburg, Berlin
 * @version $Revision: 1.1.1.1 $ - $Date: 2004/09/21 09:23:34 $
 */
public class ButtonedTextCustomizer extends DefaultPresentationManager.DefaultComponentCustomizer {

	public void customize(Component comp, PresentationDescription desc,
			Class clazz) {
		super.customize(comp, desc, clazz);
		if (!(comp instanceof JButtonedText)) {
			return;
		}
		customizeButtonedText((JButtonedText) comp, desc, clazz);
	}

	private void customizeButtonedText(JButtonedText text,
			PresentationDescription desc, Class clazz) {
		Action action = text.getAction();
		if (action == null) {
			action = createDefaultAction(text.getName());
			text.setAction(action);
		}
		ActionHelper.customizeFromPresentation(action, desc, clazz);
	}

	protected Action createDefaultAction(String actionCommand) {
		return ActionFactory.getInstance().registerAction(actionCommand,
				DefaultPresentationManager.getGroupID());
	}
}
