/*
 * Created on 09.09.2003
 *
 */
package custom.forms.view;

import javax.swing.JLabel;

import de.kleopatra.view.UIProperties;
import de.kleopatra.view.presentation.DefaultPresentationManager;
import de.kleopatra.view.presentation.SwingCustomizerMap;

/**
 * @author (C) Jeanette Winzenburg, Berlin
 * @version $Revision: 1.2 $ - $Date: 2004/10/04 12:18:34 $
 */
public class ExSwingCustomizerMap extends SwingCustomizerMap {

  /**
   * a label customizer appending a colon to label text if the
   * client property NO_LABELENDING is not set.
   */
  public static class AutoColonLabelCustomizer extends DefaultPresentationManager.LabelCustomizer {
    protected boolean useLabelEnding(JLabel label, String text) {
      return !Boolean.TRUE.equals(label.getClientProperty(UIProperties.NO_LABELENDING)) &&
          useLabelEnding(text);
    }
  }
  
	protected void initCustomizers() {
		super.initCustomizers();
		addCustomizer(JButtonedText.class,
									ButtonedTextCustomizer.class);
    addCustomizer(JLabel.class, AutoColonLabelCustomizer.class);

	}
}
