/*
 * Created on 11.02.2004
 *
 */
package custom.forms.view;

import java.awt.*;

import javax.swing.*;
import javax.swing.border.AbstractBorder;
import javax.swing.border.Border;

import de.kleopatra.view.presentation.PresentationDescription;
import de.kleopatra.view.presentation.DefaultPresentationManager.DefaultComponentCustomizer;

/**
 * @author (C) Jeanette Winzenburg, Berlin
 * @version $Revision: 1.1.1.1 $ - $Date: 2004/02/11 16:26:17 $
 */
public class RoundedBorderPanelCustomizer
	extends DefaultComponentCustomizer {
	
		public void customize(Component comp, PresentationDescription desc,
				Class clazz) {
			if (!(comp instanceof JPanel)) {
				return;
			}
			customizePanel((JPanel) comp, desc);
		}

		private void customizePanel(JPanel panel, PresentationDescription desc) {
			if (shouldDecorate(panel, desc)) {
				decorateBoder(panel, desc.getText());
			}
		}

		private boolean shouldDecorate(JPanel panel,
				PresentationDescription desc) {
			return (desc.getText() != null) && (panel.getBorder() != null)
						 && (desc.getText().length() > 0);
		}

		private void decorateBoder(JPanel panel, String title) {
			Border border = panel.getBorder();
			Border titled = new RRBorder(title);
			panel.setBorder(BorderFactory.createCompoundBorder(titled, border));
		}

		static class RRBorder extends AbstractBorder {
		 static final Font font =
			 UIManager.getFont("Label.font").deriveFont(11f);
		 static final int E = 8;
		 private String title;
		 public RRBorder(String title) {
			this.title = title;
		 }
		 public void paintBorder(
			 Component c, Graphics g, int x, int y, int width, int height) {
			FontMetrics fm = c.getFontMetrics(font);
			g.setFont(font);
			g.setColor(c.getForeground());
			g.drawString(title, x + E + E, y + fm.getAscent());
			g.drawRoundRect(x, y + fm.getHeight(), width - 1,
				height - fm.getHeight() - 1, E * 4, E * 4);
		 }
		 public Insets getBorderInsets(Component c) {
			FontMetrics fm = c.getFontMetrics(font);
			return new Insets(fm.getHeight() + E, E, E, E);
		 }
		}
	}

	

