/*
 * Created on 05.09.2003
 */
package custom.forms.view.builder;

import java.awt.Container;
import java.util.Locale;
import java.util.Vector;

import de.kleopatra.forms.view.builder.FormDescription;
import de.kleopatra.forms.view.builder.FormWriter;

/**
 * @author Seessle
 */
public class I15dXmlFormWriter extends FormWriter {

	public FormDescription getFormDescription(String resourceName,
			Class targetClass) {
		Vector names = calculateBundleNames(resourceName, Locale.getDefault());
		FormDescription desc = null;
		for (int i = names.size() - 1; (desc == null) && (i >= 0); i--) {
			desc = getFormIO().getFormDescription((String) names.get(i),
					targetClass);
		}
		return desc;
	}

	public Container buildForm(String descriptionName, Class targetClass,
			boolean customize) {
		FormDescription formDescription = getFormDescription(descriptionName,
																				targetClass);
		if (formDescription != null) {
			return buildForm(formDescription, customize);
		}
		return null;
	}

	private static Vector calculateBundleNames(String baseName, Locale locale) {

		final Vector result = new Vector();
		final String language = locale.getLanguage();
		final int languageLength = language.length();
		final String country = locale.getCountry();
		final int countryLength = country.length();
		final String variant = locale.getVariant();
		final int variantLength = variant.length();
		result.addElement(baseName);
		if (languageLength + countryLength + variantLength == 0) {

			//The locale is "", "", "".
			return result;
		}
		final StringBuffer temp = new StringBuffer(baseName);
		temp.append('_');
		temp.append(language);
		if (languageLength > 0) {
			result.addElement(temp.toString());
		}
		if (countryLength + variantLength == 0) {
			return result;
		}
		temp.append('_');
		temp.append(country);
		if (countryLength > 0) {
			result.addElement(temp.toString());
		}
		if (variantLength == 0) {
			return result;
		}
		temp.append('_');
		temp.append(variant);
		result.addElement(temp.toString());
		return result;
	}

	public static void main(String[] args) {
		Vector v = calculateBundleNames("foo", new Locale("de", "DE", "EUR"));
		System.out.println(v);
	}
}
