package de.kleopatra.forms.examples;

import javax.swing.JComponent;
import javax.swing.JTextField;

import de.kleopatra.forms.view.builder.*;
import de.kleopatra.support.KleoUtilities;

/** Example how to use a pre-built layout resource.
 *
 *  demonstrates:
 *
 *  <ul>
 *  <li> how to load an ui on startup from a resource relative
 *      to the client
 *  <li> how to find a widget
 *  </ul>
 *
 *  @version $Revision: 1.3 $ $Date: 2004/09/30 10:16:41 $
 *  @author (C) 2003 Jeanette Winzenburg
 *
 */
public class QuickstartD extends AbstractForm {

  private static final String SIMPLE_FORM_RESOURCE = "quickstartd";
  public String getResource() {
    return SIMPLE_FORM_RESOURCE;
  }

//---------------------------accessing widgets
  protected void bind(JComponent form) {
    JTextField comp = KleoUtilities.findTextField(form, "company");
    if (comp != null) {
      comp.setText("Swing Empire");
    }
  }

//---------------------------Main
  public static void main(String[] args) {
    Form form = new QuickstartD();
    FormUtils.createFrame(form, true);
  }
}
